• HDU 5544 Ba Gua Zhen dfs+高斯消元


    Ba Gua Zhen

    Problem Description
    During the Three-Kingdom period, there was a general named Xun Lu who belonged to Kingdom Wu. Once his troop were chasing Bei Liu, he was stuck in the Ba Gua Zhen from Liang Zhuge. The puzzle could be considered as an undirected graph with N vertexes and M edges. Each edge in the puzzle connected two vertexes which were ui and vi with a length of wi. Liang Zhuge had great interests in the beauty of his puzzle, so there were no self-loops and between each pair of vertexes, there would be at most one edge in the puzzle. And it was also guaranteed that there was at least one path to go between each pair of vertexes.

    Fortunately, there was an old man named Chengyan Huang who was willing to help Xun Lu to hack the puzzle. Chengyan told Xun Lu that he had to choose a vertex as the start point, then walk through some of the edges and return to the start point at last. During his walk, he could go through some edges any times. Since Liang Zhuge had some mysterious magic, Xun Lu could hack the puzzle if and only if he could find such a path with the maximum XOR sum of all the edges length he has passed. If the he passed some edge multiple times, the length would also be calculated by multiple times. Now, could you tell Xun Lu which is the maximum XORcircuit path in this puzzle to help him hack the puzzle?
     
    Input
     
    The first line of the input gives the number of test cases, T(1T30)T test cases follow.

    Each test case begins with two integers N(2N5×104) and M(1M105) in one line. Then M lines follow. Each line contains three integers uiviand wi(1ui,viN,0wi2601) to describe all the edges in the puzzle.
     
    Output
     
    For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the maximum XOR sum of one circuit path in the puzzle.
     
    Sample Input
     
    2 3 3 1 2 1 1 3 2 2 3 0 6 7 1 2 1 1 3 1 2 3 1 3 4 4 4 5 2 4 6 2 5 6 2
     
    Sample Output
     
    Case #1: 3 Case #2: 3
     
    Hint
    A XOR takes two bit patterns of equal length and performs the logical exclusive OR operation on each pair of corresponding bits. The result in each position is 1 if only the first bit is 1 or only the second bit is 1, but will be 0 if both are 0 or both are 1. In this we perform the comparison of two bits, being 1 if the two bits are different, and 0 if they are the same.
     
     
    题意:
      给你n个点m条边的无向图
      让你求一条回路使得经过每条路径权值异或和最大,求这个最大值
      路径可以多次经过
    题解:
      画图可以发现
      把所有环挑出来,任意组合就好
      任意个数组合使得异或和最大,这特么就是个原题了
    #include<bits/stdc++.h>
    using namespace std;
    #pragma comment(linker, "/STACK:102400000,102400000")
    #define ls i<<1
    #define rs ls | 1
    #define mid ((ll+rr)>>1)
    #define pii pair<int,int>
    #define MP make_pair
    typedef long long LL;
    const long long INF = 1e18+1LL;
    const double Pi = acos(-1.0);
    const int N = 5e5+10, M = 1e3+20, mod = 1e9+7, inf = 2e9;
    
    int head[N],t,cas = 1;
    struct ss{
        int to,next;
        LL value;
    }e[N*2];
    int vis[N],cnt,T,n,m;
    LL dep[N],ins[N],a[N];
    void add(int u,int v,LL w) {
        e[t].next = head[u];
        e[t].to = v;
        e[t].value = w;
        head[u] = t++;
    }
    void dfs(int u,int f) {
        vis[u] = vis[f] + 1;
        for(int i = head[u]; i; i = e[i].next) {
            int to = e[i].to;
            if(to == f || (vis[to] && vis[to] < vis[u])) continue;
            if(vis[to]) {
                a[++cnt] = e[i].value ^ dep[to] ^ dep[u];
                continue;
            }
            dep[to] = dep[u] ^ e[i].value;
            dfs(to,u);
        }
    }
    int main() {
        scanf("%d",&T);
        while(T--) {
            scanf("%d%d",&n,&m);
            memset(head,0,sizeof(head));
            memset(vis,0,sizeof(vis));
            memset(dep,0,sizeof(dep));
            memset(ins,0,sizeof(ins));
            t = 1;
            cnt = 0;
            for(int i = 1; i <= m; ++i) {
                int u,v;LL w;
                scanf("%d%d%I64d",&u,&v,&w);
                add(u,v,w);
                add(v,u,w);
            }
            dfs(1,0);
            for(int i = 1; i <= cnt; ++i) {
                for(int j = 62; j >= 0; --j) {
                    if(a[i]&(1LL<<j)) {
                        if(!ins[j]) {
                            ins[j] = a[i];
                            break;
                        }
                        a[i] ^= ins[j];
                    }
                }
            }
            LL ans = 0;
            for(int i = 62; i >= 0; --i) {
                if((ins[i]^ans) > ans) ans^=ins[i];
            }
            printf("Case #%d: %I64d
    ",cas++,ans);
        }
        return 0;
    }
  • 相关阅读:
    day21_map&debug
    Error: A JNI error has occurred, please check your installation and try again
    day20_比较器&Map
    day1819_List&Set&Genericity
    day17_Collection
    String类是不可改变的,所以你一旦创建了String对象,那它的值就无法改变了
    day15_api01
    day16_api02
    渡河问题
    leetcode 春季个人赛
  • 原文地址:https://www.cnblogs.com/zxhl/p/6675043.html
Copyright © 2020-2023  润新知